function [ target_quantile ] = CMC_quantile(target_probability, CMC_rep, randseed, mu, sigma, x_mu, x_sigma)
%This function computes the quantile based on the CMC with given parameters 
% prob = 0.95; %target probability
% n_rep = 10^6;
% randseed = 100
% function handles of mu & sigma

%p_var, kappa, rho, delta, MtoN) 
% p_var = 1; %number of variables
% kappa = 2; %non-linearity
% rho = 0.6; %metamodeling quality
% delta = 2; %difference in densities
% MtoN = 0.3; %input sample size ratio;  M / N_T )

rng(randseed)
sample_x = mvnrnd(x_mu, x_sigma, CMC_rep);


%norm_x = sqrt(sum(sample_x.^2,2)); %NOTE: sample_x must be in a form of n by p
sample_y = normrnd(mu(sample_x), sigma(sample_x));   


target_quantile = quantile(sample_y, target_probability);

end

