%10182014:  Cannamela3D pvar = 3, N_exp = 2000
%10172014:  Ackley pvar = 1, N_exp = 2000
%06092014:  MVv2.3. N_exp = 2000
%06062014:  MVv2.2. N_exp = 1000
%05232014:  MVv1.2. N_exp=500; N_T = 1000;
%05212014:  Take 30 hours:  MVv1.1. N_exp=500; N_T = 3000; Rel ratios are added for P_T tests. Parameter levels are reduced. 
%04102014:  The base rho is set at 0.50 for an extensive kappa test
%04092014:  More extensive kappa and rho values are tried.
global savefilename;

global p_var; %number of variablesclear
global target_probability;
global kappa; %non-linearity
global rho; %metamodeling quality - oscillating pattern
global beta; %metamodeling quality - global pattern
global delta; %difference in densities
global MtoN; %input sample size ratio;  M / N_T


global mu;
global sigma; %In order to set it independent of x when performing experiment for delta

global mu_hat;
global sigma_hat;

% Default Experiment setup
SetDefaultParameters();

Methods = {'SIS1', 'SIS2', 'BIS', 'CMC'};

savefilename = 'Cannamela3D_v1_1018_Nrep2000.mat';  %Don't need to be a global variable.

tstart = tic;




%% Parameter 2: Failure probability - delta of 1 (larger difference between f and q* as l increases)
SetDefaultParameters();
targetP_list = 1-[.100, .050, .010];%1-[.100, .050, .010, .005, .001]; % [0.90, 0.95, 0.99];

targetP_POEs = cell(length(targetP_list), length(Methods));
targetP_Means = zeros(length(targetP_list), length(Methods)+1); 
targetP_SEs = zeros(length(targetP_list), length(Methods)+3);
for i = 1:length(targetP_list)
    target_probability = targetP_list(i);
    for j = 1:length(Methods)
        eval(horzcat(Methods{j}))
        targetP_POEs{i,j} = POE_estimate_of_exp;
        targetP_Means(i,j) = double(accurate_mean(POE_estimate_of_exp));
        targetP_SEs(i,j) = double(accurate_std(POE_estimate_of_exp));       
    end
    targetP_Means(i,length(Methods)+1) = BIS_num_integration_P();
    CMC_SD = sqrt(targetP_Means(i,length(Methods)+1)*(1-targetP_Means(i,length(Methods)+1))/N_T);
    targetP_SEs(i,length(Methods)+1) = (targetP_SEs(i,1)/CMC_SD)^2; %Rel ratio for SIS1 to CMC
    targetP_SEs(i,length(Methods)+2) = (targetP_SEs(i,2)/CMC_SD)^2; %Rel ratio for SIS2 to CMC
    targetP_SEs(i,length(Methods)+3) = (targetP_SEs(i,3)/CMC_SD)^2; %Rel ratio for BIS to CMC
end

save(savefilename);
%% Parameter 2: Failure probability - delta of -1 (only little difference between f and q* although l increases)
SetDefaultParameters();
delta = -1;
UpdateParameters();

targetP_list = 1-[.100, .050, .010];%1-[.100, .050, .010, .005, .001]; %[0.90, 0.95, 0.99];

targetP_POEs_neg_delta = cell(length(targetP_list), length(Methods));
targetP_Means_neg_delta = zeros(length(targetP_list), length(Methods)+1); 
targetP_SEs_neg_delta = zeros(length(targetP_list), length(Methods)+3);
for i = 1:length(targetP_list)
    target_probability = targetP_list(i);
    for j = 1:length(Methods)
        eval(horzcat(Methods{j}))
        targetP_POEs_neg_delta{i,j} = POE_estimate_of_exp;
        targetP_Means_neg_delta(i,j) = double(accurate_mean(POE_estimate_of_exp));
        targetP_SEs_neg_delta(i,j) = double(accurate_std(POE_estimate_of_exp));        
    end  
    targetP_Means_neg_delta(i,length(Methods)+1) = BIS_num_integration_P();
    CMC_SD = sqrt(targetP_Means_neg_delta(i,length(Methods)+1)*(1-targetP_Means_neg_delta(i,length(Methods)+1))/N_T);
    targetP_SEs_neg_delta(i,length(Methods)+1) = (targetP_SEs_neg_delta(i,1)/CMC_SD)^2; %Rel ratio for SIS1 to CMC
    targetP_SEs_neg_delta(i,length(Methods)+2) = (targetP_SEs_neg_delta(i,2)/CMC_SD)^2; %Rel ratio for SIS2 to CMC
    targetP_SEs_neg_delta(i,length(Methods)+3) = (targetP_SEs_neg_delta(i,3)/CMC_SD)^2; %Rel ratio for BIS to CMC
end

save(savefilename);


%% Parameter 3: Locality
% SetDefaultParameters();
% 
% kappa_list = [0, 0.5, 1, 2, 4]; %2.^(0:1:4);%0:0.5:1; %[0:0.25:1, 1.5, 2:5]; %0:1:5;  %0:0.5:1;
% 
% Kappa_POEs = cell(length(kappa_list), length(Methods));
% Kappa_Means = zeros(length(kappa_list), length(Methods)+1); 
% Kappa_SEs = zeros(length(kappa_list), length(Methods));
% for i = 1:length(kappa_list)
%     kappa = kappa_list(i);
%     UpdateParameters();
%     for j = 1:length(Methods)
%         eval(horzcat(Methods{j}))
%         Kappa_POEs{i,j} = POE_estimate_of_exp;
%         Kappa_Means(i,j) = double(accurate_mean(POE_estimate_of_exp));
%         Kappa_SEs(i,j) = double(accurate_std(POE_estimate_of_exp));        
%     end
%     Kappa_Means(i,length(Methods)+1) = BIS_num_integration_P();
% end
% 
% save(savefilename);
% %% Parameter 4-1: Metamodeling accuracy - oscillating pattern
% 
% SetDefaultParameters();
% rho_list =  0:0.5:1; %0:0.25:1; %[0.5 0.6 0.75 0.8 1]; %0:0.5:1;
% 
% rho_POEs = cell(length(rho_list), length(Methods));
% rho_Means = zeros(length(rho_list), length(Methods)+1); 
% rho_SEs = zeros(length(rho_list), length(Methods));
% for i = 1:length(rho_list)
%     rho = rho_list(i);
%     UpdateParameters();
%     for j = 1:length(Methods)
%         eval(horzcat(Methods{j}))
%         rho_POEs{i,j} = POE_estimate_of_exp;
%         rho_Means(i,j) = double(accurate_mean(POE_estimate_of_exp));
%         rho_SEs(i,j) = double(accurate_std(POE_estimate_of_exp));        
%     end  
%     rho_Means(i,length(Methods)+1) = BIS_num_integration_P();
% end
% 
% 
% save(savefilename);
% 
% %% Parameter 4-2: Metamodeling accuracy - global pattern
% 
% SetDefaultParameters();
% rho = 1; %0;
% UpdateParameters();
% 
% beta_list =  0.95:0.05:1.05; %[0.80, 0.90:0.05:1.10, 1.20]; %0.90:0.05:1.10; 
% 
% beta_POEs = cell(length(beta_list), length(Methods));
% beta_Means = zeros(length(beta_list), length(Methods)+1); 
% beta_SEs = zeros(length(beta_list), length(Methods));
% for i = 1:length(beta_list)
%     beta = beta_list(i);
%     UpdateParameters();
%     for j = 1:length(Methods)
%         eval(horzcat(Methods{j}))
%         beta_POEs{i,j} = POE_estimate_of_exp;
%         beta_Means(i,j) = double(accurate_mean(POE_estimate_of_exp));
%         beta_SEs(i,j) = double(accurate_std(POE_estimate_of_exp));        
%     end  
%     beta_Means(i,length(Methods)+1) = BIS_num_integration_P();
% end
% 
% 
% save(savefilename);
% %% Parameter 6: Input sample size ratio
% SetDefaultParameters();
% MtoN_list = 0.10:0.20:0.90;
% 
% MtoN_POEs = cell(length(MtoN_list), 1);
% MtoN_Means = zeros(length(MtoN_list), 1); 
% MtoN_SEs = zeros(length(MtoN_list), 1);
% for i = 1:length(MtoN_list)
%     MtoN = MtoN_list(i);
%     for j = 1  %:length(Methods)
%         eval(horzcat(Methods{j}))
%         MtoN_POEs{i,j} = POE_estimate_of_exp;
%         MtoN_Means(i,j) = double(accurate_mean(POE_estimate_of_exp));
%         MtoN_SEs(i,j) = double(accurate_std(POE_estimate_of_exp));        
%     end    
% end


%% Save the final workspace
save(savefilename);

telapsed = toc(tstart);
sprintf('Elapsed Time = %g seconds = %g minutes = %g hours', telapsed, telapsed/60, telapsed/(60*60))

