global savefilename;

global p_var; %number of variablesclear
global target_probability;
global kappa; %non-linearity
global rho; %metamodeling quality
global delta; %difference in densities
global MtoN; %input sample size ratio;  M / N_T

global N_exp; % N_exp = Total_number_of_experiments_for_each_estimator
global N_T; % N = Total computational resource (i.e., total number of sampling execution from the conditional distribution, Y | X = x_i.)

global beta;

global mu;
global sigma; %In order to set it independent of x when performing experiment for delta

global mu_hat;

% Default Experiment setup
SetDefaultParameters();

Methods = {'SIS1', 'SIS2', 'BIS', 'CMC'};
%% Slope of conditional variance: beta
% SetDefaultParameters();
% beta_list = 0:1;
% 
% beta_numP = zeros(length(beta_list), 1);
% for i = 1:length(beta_list)
%     beta = beta_list(i);
%     sigma = (@(x) 1  + beta.*abs(x) );
%     for j = 1
%         beta_numP(i,j) = BIS_num_integration_P();
%     end    
% end

%% Parameter 2: Failure probability
SetDefaultParameters();
targetP_list = [0.90, 0.95, 0.99];

targetP_numP = zeros(length(targetP_list), 1);
for i = 1:length(targetP_list)
    target_probability = targetP_list(i);
    for j = 1
        targetP_numP(i,j) = BIS_num_integration_P();
    end    
end


%% Parameter 2: Failure probability (delta = -1)
SetDefaultParameters();
delta = -1;
mu = (@(x) (0.95.*delta).*x.^2.*(1 + 0.5.*cos(10.*kappa.*x) + 0.5.*cos(20.*kappa.*x) ));
targetP_list = [0.90, 0.95, 0.99];

targetP_numP = zeros(length(targetP_list), 1);
for i = 1:length(targetP_list)
    target_probability = targetP_list(i);

    
    for j = 1
        targetP_numP(i,j) = BIS_num_integration_P();
    end    
end
%% Parameter 3: Non-linearity 
SetDefaultParameters();
kappa_list = 0:0.5:1;


Kappa_numP = zeros(length(targetP_list), 1);

for i = 1:length(kappa_list)
    kappa = kappa_list(i);
    mu = (@(x) (0.95.*delta).*x.^2.*(1 + 0.5.*cos(10.*kappa.*x) + 0.5.*cos(20.*kappa.*x) ));
    for j = 1
        Kappa_numP(i,j) = BIS_num_integration_P();
      
    end    
end


%% Parameter 4: Metamodeling accuracy 
SetDefaultParameters();
rho_list = 0:0.5:1;

rho_numP = zeros(length(targetP_list), 1);

for i = 1:length(rho_list)
    rho = rho_list(i);
    for j = 1
        rho_numP(i,j) = BIS_num_integration_P();
        %savefilename = horzcat(Methods{j},'_', num2str(p_var),'_', num2str(kappa),'_',num2str(rho),'_',num2str(delta),'_',num2str(MtoN), '.mat'); % 
    end    
end



%% Parameter 5: Difference between f and q* 
SetDefaultParameters();
rho = 0;
sigma = (@(x) 1 );
delta_list = 0:3; %0:2:6; %

delta_numP = zeros(length(targetP_list), 1);

for i = 1:length(delta_list)
    delta = delta_list(i);
    for j = 1
        delta_numP(i,j) = BIS_num_integration_P();
        %savefilename = horzcat(Methods{j},'_', num2str(p_var),'_', num2str(kappa),'_',num2str(rho),'_',num2str(delta),'_',num2str(MtoN), '.mat'); % 
    end    
end




%% Parameter 6: Input sample size ratio
SetDefaultParameters();
MtoN_list = 0.10:0.20:0.90;

MtoN_numP = zeros(length(targetP_list), 1);

for i = 1:length(MtoN_list)
    MtoN = MtoN_list(i);
    for j = 1  %:length(Methods)
       MtoN_numP(i,j) = BIS_num_integration_P();
        %savefilename = horzcat(Methods{j},'_', num2str(p_var),'_', num2str(kappa),'_',num2str(rho),'_',num2str(delta),'_',num2str(MtoN), '.mat'); % 
    end    
end

