function [] = UpdateParameters()
%Assume that x is a n by p matrix. 

global p_var; %number of variablesclear
global target_probability;
global kappa; %non-linearity
global rho; %metamodeling quality - oscillating pattern
global beta; %metamodeling quality - global pattern
global delta; %difference in densities
global MtoN; %input sample size ratio;  M / N_T

global N_exp; % N_exp = Total_number_of_experiments_for_each_estimator
global N_T; % N = Total computational resource (i.e., total number of sampling execution from the conditional distribution, Y | X = x_i.)


global mu;
global sigma; %In order to set it independent of x when performing experiment for delta

global mu_hat;
global sigma_hat;


mu = (@(x) (0.95.*delta).*(sum(x.^2,2)./p_var).*(1 + 0.5.*(sum(cos(10.*kappa.*x),2)./p_var) + 0.5.*(sum(cos(20.*kappa.*x),2)./p_var) ));
sigma = (@(x) 1 + 0.7.*sqrt(sum(x.^2,2)./p_var) + 0.4.*(sum(cos(x),2)./p_var) + 0.3.*(sum(cos(14.*x),2)./p_var) );

mu_hat = (@(x) (0.95.*beta.*delta).*(sum(x.^2,2)./p_var).*(1 + 0.5.*rho.*(sum(cos(10.*kappa.*x),2)./p_var) + 0.5.*rho.*(sum(cos(20.*kappa.*x),2)./p_var) ));
sigma_hat = (@(x) 1 + 0.7.*sqrt(sum(x.^2,2)./p_var) + 0.4.*rho.*(sum(cos(x),2)./p_var) + 0.3.*rho.*(sum(cos(14.*x),2)./p_var) );

end

